unit im_Blendfrm;

{*********************************************}
{  This unit is a part of ImageE              }
{  Copyright  2003-2004 R.Geurts             }
{  See Readme.txt for licence information     }
{*********************************************}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, ExtCtrls, Spin, GR32_Image, GR32_RangeBars,
  gr32,im_childwin,gr32_layers,
  gr32_lowlevel,gr32_filters,gr32_transforms,
  im_blending;

type
  TBlendCtrlForm = class(TForm)
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ComboBox3: TComboBox;
    HelpBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
  private
  public

  end;

var
  BlendCtrlForm: TBlendCtrlForm;
  bmp1:Tbitmap32;
  bmp2:Tbitmap32;
  bmp3:Tbitmap32;
const
     RP = 0.2989;
     GP = 0.5866;
     BP = 1 - RP - GP;

implementation

uses   im_D5,im_MainFRM;

{$R *.DFM}

procedure TBlendCtrlForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  BlendCtrlFormX := BlendCtrlForm.left;
  BlendCtrlFormY:= BlendCtrlForm.top;
end;

procedure TBlendCtrlForm.FormCreate(Sender: TObject);
begin
  left := BlendCtrlFormX;
  top := BlendCtrlFormY;
  Bmp1:=tbitmap32.Create;
  Bmp2:=tbitmap32.Create;
  Bmp3:=tbitmap32.Create;
end;

procedure TBlendCtrlForm.FormShow(Sender: TObject);
var
{    Pos: TPoint;}
{    L: TBitmapLayer;
    w0,h0,w1,h1,w2,h2:integer; }
    i:integer;
{  W, H: Integer; }
begin
  combobox1.Clear;
  combobox2.clear;
  for I:=0 To MainForm.MDIChildCount -1 do
  begin
       ComboBox1.Items.Add((MainForm.MDIChildren[I].Caption));
       ComboBox2.Items.Add((MainForm.MDIChildren[I].Caption));
  end;

  if combobox1.items.count>=2 then
 begin
   bmp1.Assign((Mainform.MDIChildren[0] as TMDIChild).ImageView1.bitmap);
   bmp2.Assign((Mainform.MDIChildren[1] as TMDIChild).ImageView1.bitmap);
   combobox1.ItemIndex:=0;
   combobox2.ItemIndex:=1;
   combobox3.ItemIndex:=0;
 end;
end;


procedure TBlendCtrlForm.ComboBox1Change(Sender: TObject);
begin
 if Combobox1.ItemIndex >= 0 then begin
 bmp1.Assign((Mainform.MDIChildren[Combobox1.ItemIndex] as TMDIChild).ImageView1.bitmap);
 end;
end;

procedure TBlendCtrlForm.ComboBox2Change(Sender: TObject);
begin
 if Combobox1.ItemIndex >= 0 then begin
   bmp2.Assign((Mainform.MDIChildren[Combobox2.ItemIndex] as TMDIChild).ImageView1.bitmap);
 end;
end;

//------------


procedure TBlendCtrlForm.BitBtn1Click(Sender: TObject);
var
  Child: TMDIChild;
  h,w:integer;
begin
  h:=bmp1.Height;
  if bmp2.height>h then h:=bmp2.height;
  w:=bmp1.width;
  if bmp2.width>W then w:=bmp2.Width;

  mainForm.AddMDIChild(w,h);
  Child := Mainform.ActiveMDIChild as TMDIChild;
  Arithmetic_MergeBitmaps(bmp1,bmp2,combobox3.items[Combobox3.ItemIndex]);
  Child.imageview1.bitmap.assign(bmp2);
  child.Changed := true;
end;



procedure TBlendCtrlForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(10000);
end;

end.
