unit im_QPOzoneMushFrm;

{original release 2-july-2000
  janFX is written by Jan Verhoeven ...
    procedure Plasma(src1,src2,dst:Tbitmap;scale,turbulence:extended);  }

interface

uses
  Windows, Messages, SysUtils, Classes, Math,
  Graphics, Controls, Forms, Dialogs,  Printers,
    jpg,jpeg,pngimage,
  ExtCtrls, GR32_Image, Menus, StdCtrls, Buttons;

type
  TOzoneMushForm = class(TForm)
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Mushit: TMenuItem;
    SaveAs1: TMenuItem;
    N3: TMenuItem;
    Print1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    Help1: TMenuItem;
    ColorDialog1: TColorDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    LoadImage1: TMenuItem;
    ScrollBox1: TScrollBox;
    ImgView321: TImage32;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Close1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
PROCEDURE PrintBitmap(Canvas:  TCanvas;
              DestRect:  TRect;  Bitmap:  TBitmap);
    procedure Help1Click(Sender: TObject);
    procedure MushitClick(Sender: TObject);
    procedure LoadImage1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OzoneMushForm: TOzoneMushForm;

implementation
uses im_D5,im_basic;
{$R *.DFM}

procedure TOzoneMushForm.FormCreate(Sender: TObject);
var Bitmap:TBitmap;
begin
  top := OzoneMushFormY;
  left := OzoneMushFormX;
  Randomize;
  Bitmap:=TBitmap.Create;
  Bitmap.Width:=360;
  Bitmap.Height:=480;
  ImgView321.Bitmap.assign(Bitmap);
  Bitmap.Free;
end;

procedure TOzoneMushForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  OzoneMushFormX := OzoneMushForm.left;
  OzoneMushFormY := OzoneMushForm.top;
end;

procedure TOzoneMushForm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TOzoneMushForm.LoadImage1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir :=ImagePath;
  if OpenDialog1.Execute then
  begin
    Application.ProcessMessages;
    ImagePath:=ExtractFilePath(OpenDialog1.FileName);
    ImgView321.Bitmap.LoadFromFile(OpenDialog1.FileName);
  end;
end;

procedure TOzoneMushForm.SaveAs1Click(Sender: TObject);
begin
  SaveDialog1.InitialDir :=ImagePath;
    SaveDialog1.Filter :='*.bmp';
  if SaveDialog1.Execute then
    ImgView321.Bitmap.Savetofile(ChangeFileExt(SaveDialog1.Filename,'.bmp'));
end;

procedure TOzoneMushForm.Print1Click(Sender: TObject);
var
  PrintRect: TRect;
  TempBitmap:TBitmap;
begin
  if PrinterSetupDialog1.Execute {PrintDialog1.Execute} then
  begin
    Application.ProcessMessages;
    { Add code to print current file }
    with Printer do
    begin
      BeginDoc;
      TempBitmap := TBitmap.Create;
      TempBitmap.Assign(ImgView321.Bitmap);
      {Image1.Picture.Bitmap or FBitmap
      Check to see if enlarged print is available}
{      if PrintBigChecked then
      begin}
      If((PageWidth > (ImgView321.Bitmap.Width * 4)) and
        (PageHeight > (ImgView321.Bitmap.Height * 4))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (ImgView321.Bitmap.Width * 4)) div 2,
          (PageHeight - (ImgView321.Bitmap.Height * 4)) div 2,
          (((PageWidth - (ImgView321.Bitmap.Width * 4)) div 2)
          + (ImgView321.Bitmap.Width * 4)),
          (((PageHeight - (ImgView321.Bitmap.Height * 4)) div 2)
          + (ImgView321.Bitmap.Height * 4)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
{        Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end else
      If((PageWidth > (ImgView321.Bitmap.Width * 2)) and
        (PageHeight > (ImgView321.Bitmap.Height * 2))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (ImgView321.Bitmap.Width * 2)) div 2,
          (PageHeight - (ImgView321.Bitmap.Height * 2)) div 2,
          (((PageWidth - (ImgView321.Bitmap.Width * 2)) div 2)
          + (ImgView321.Bitmap.Width * 2)),
          (((PageHeight - (ImgView321.Bitmap.Height * 2)) div 2)
          + (ImgView321.Bitmap.Height * 2)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
        {Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end;
      EndDoc;
      TempBitmap.Free;
    end;
  end;
end;
  // Based on posting to borland.public.delphi.winapi by Rodney E Geraghty,
  // 8/8/97.  Used to print bitmap on any Windows printer.
PROCEDURE TOzoneMushForm.PrintBitmap(Canvas:  TCanvas;
              DestRect:  TRect;  Bitmap:  TBitmap);
    VAR
      BitmapHeader:  pBitmapInfo;
      BitmapImage :  POINTER;
      HeaderSize  :  DWORD;
      ImageSize   :  DWORD;
  BEGIN
    GetDIBSizes(Bitmap.Handle, HeaderSize, ImageSize);
    GetMem(BitmapHeader, HeaderSize);
    GetMem(BitmapImage,  ImageSize);
    TRY
      GetDIB(Bitmap.Handle, Bitmap.Palette, BitmapHeader^, BitmapImage^);
      StretchDIBits(Canvas.Handle,
                    DestRect.Left, DestRect.Top,     // Destination Origin
                    DestRect.Right  - DestRect.Left, // Destination Width
                    DestRect.Bottom - DestRect.Top,  // Destination Height
                    0, 0,                            // Source Origin
                    Bitmap.Width, Bitmap.Height,     // Source Width & Height
                    BitmapImage,
                    TBitmapInfo(BitmapHeader^),
                    DIB_RGB_COLORS,
                    SRCCOPY)
    FINALLY
      FreeMem(BitmapHeader);
      FreeMem(BitmapImage)
    END
END {PrintBitmap};

procedure TOzoneMushForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(13400);
end;

procedure TOzoneMushForm.MushitClick(Sender: TObject);
var
   src1, src2, dst: Tbitmap;
    scale,turbulence: extended;
   cval,sval:array[0..255] of integer;
   i,x,y,w,h,xx,yy:integer;
   Asin,Acos:extended;
   ps1,ps2,pd:pbytearray;
begin  {Ozone Mush}
{  imagefliphoriz(ImgView321.Bitmap); }
  dst:=TBitmap.Create;
  dst.Width:=ImgView321.Width;
  dst.Height:=ImgView321.Height;
  dst.assign(ImgView321.Bitmap);
  src2:=TBitmap.Create;
  src2.Width:=ImgView321.Width;
  src2.Height:=ImgView321.Height;
  src2.assign(ImgView321.Bitmap);
  src1:=TBitmap.Create;
  src1.Width:=ImgView321.Width;
  src1.Height:=ImgView321.Height;
  src1.assign(ImgView321.Bitmap);
   w:=src1.width;
   h:=src1.height;
   Asin:=1;   Acos:=1;{set by call..this is a waste}
   scale:=Random(100)+5;
      {if scale<5 then scale:=5;}
   turbulence :=Random(350)+10;
   {if turbulence<10 then turbulence:=10;}
   for i:=0 to 255 do begin
     sincos(i/turbulence,Asin,Acos);
     sval[i]:=round(-scale*Asin);
     cval[i]:=round(scale*Acos);
   end;
   for i:=1 to random(10) do begin
    Application.ProcessMessages;
    OzoneMushForm.Caption:= Inttostr(Round(i/10)*100);

   dst.assign(ImgView321.Bitmap);
   for y:=0 to h-1 do begin
      pd:=dst.scanline[y];
      ps2:=src2.scanline[y];
     for x:=0 to w-1 do begin
      xx:=x+sval[ps2[x*3]];
      yy:=y+cval[ps2[x*3]];
      if (xx>=0)and(xx<w)and (yy>=0)and(yy<h) then begin
        ps1:=src1.scanline[yy];
        pd[x*3]:=ps1[xx*3];
        pd[x*3+1]:=ps1[xx*3+1];
        pd[x*3+2]:=ps1[xx*3+2];
        end;
      end;
    end;
  imagefliphoriz(ImgView321.Bitmap);
  end;
  ImgView321.Bitmap.assign(dst);
  dst.free;
  src2.free;
  src1.free;
OzoneMushForm.Caption:='Ozone Mush';
end;

end.
