unit im_binaryFRM;

{*********************************************}
{  This unit is a part of ImageE              }
{  Copyright  2003-2004 R.Geurts             }
{  See Readme.txt for licence information     }
{*********************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls,
  gr32,im_effects,im_childwin,math;

type
  TBinaryCTRLForm = class(TForm)
    TrackBar1: TTrackBar;
    Edit1: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    HelpBtn: TSpeedButton;
    procedure TrackBar1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
  src:tbitmap32;
  dst:tbitmap32;
  srcrect,dstrect:trect;
    { Public declarations }
  end;

var
  BinaryCTRLForm: TBinaryCTRLForm;
implementation


uses   im_D5,im_MainFrm;
{$R *.dfm}

procedure TBinaryCTRLForm.FormCreate(Sender: TObject);
begin
  left := BinaryCTRLFormX;
  top := BinaryCTRLFormY;
  src:=tbitmap32.create;
  dst:=tbitmap32.create;
end;
procedure TBinaryCTRLForm.FormShow(Sender: TObject);
begin
   src.assign(dst);
   trackbar1.Min:=0;
   trackbar1.Max:=255;
   trackbar1.Position:=128;
   trackbar1.Frequency:=10;
end;

procedure TBinaryCTRLForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  BinaryCTRLFormX := BinaryCTRLForm.left;
  BinaryCTRLFormY:= BinaryCTRLForm.top;
end;

procedure TBinaryCTRLForm.TrackBar1Change(Sender: TObject);
begin
  dst.assign(src);
  edit1.text:=floattostr(trackbar1.position);
  Effect_ToBinary(dst,trackbar1.position);

  with MainForm.ActiveMDIChild as TMdiChild do begin
   if selectionactive=true then
   imageview1.Bitmap.Draw(srcrect,dstrect,dst)
   else
   imageview1.Bitmap.Assign(dst);
   Imageview1.Repaint;
  end;
end;


procedure TBinaryCTRLForm.Edit1Change(Sender: TObject);
begin
 trackbar1.Position:=ensurerangeiiii(strtointdef(edit1.text,0),trackbar1.min,trackbar1.max);
end;



procedure TBinaryCTRLForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(7000);
end;

end.
