unit im_convFRM;

{*********************************************}
{  This unit is a part of ImageE              }
{  Copyright  2003-2004 R.Geurts             }
{  See Readme.txt for licence information     }
{*********************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, GR32_Image, ExtCtrls, Grids,
   GR32, im_Convolution,JPEG,GR32_Filters,im_childwin;
type
  Tconvctrlform = class(TForm)
    StringGrid1: TStringGrid;
    dst: TImage32;
    ListBox1: TListBox;
    Label1: TLabel;
    Edit1: TEdit;
    MaskEdit2: TEdit;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    PreviewButton: TButton;
    CheckBox1: TCheckBox;
    Label3: TLabel;
    RotateBtn: TSpeedButton;
    HelpBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);

    procedure RadioGroup1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure initgrid;
    procedure UpdateImage;
    procedure PreviewButtonClick(Sender: TObject);
    procedure RotateMatrix;
    procedure gridtoMatrix;
    procedure MatrixtoGrid;
    function getmatrixsize():integer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RotateBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);

  private
    tempbmp:tbitmap32;
    EffMatrix : array [0..6,0..6] of integer;
//    divisor:integer;
//    mx:integer; //size of matrix
    { Private declarations }
  public
    { Public declarations }
  end;

var
  convctrlform: Tconvctrlform;

implementation

uses im_D5, im_MainFrm;

{$R *.dfm}

procedure Tconvctrlform.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  convctrlformX := convctrlform.left;
  convctrlformY:= convctrlform.top;
end;
procedure Tconvctrlform.FormCreate(Sender: TObject);
var i:integer;
begin
  left := convctrlformX;
  top := convctrlformY;
//fill listbox
  for i := Low(CONVOLUTION_FILTERNAMES) to High(CONVOLUTION_FILTERNAMES) do begin
    listbox1.Items.Add(CONVOLUTION_FILTERNAMES[i]);
  end;
  listbox1.ItemIndex := 0;
end;

procedure Tconvctrlform.initgrid;
var i,j:integer;
begin
for i:=0 to 8 do for j:=0 to 8 do stringgrid1.cells[i,j]:='0';
end;

procedure Tconvctrlform.ListBox1Click(Sender: TObject);
var i,j:integer;
    hm:tconvolutionkernel;
    k:integer;
begin
hm:=(KERNEL_ARRAY[listbox1.ItemIndex]);
k:=0;
for i:=0 to 6 do for j:=0 to 6 do
  begin
    effmatrix[j,i]:=hm[k];
    inc(k);
  end;
  edit1.text:=inttostr(hm[49]);
  matrixtogrid;
  if checkbox1.Checked then previewbuttonclick(self);
end;

procedure Tconvctrlform.RadioGroup1Click(Sender: TObject);
begin
 { case radiogroup1.Itemindex of
  0: begin
      stringgrid1.rowcount:=3; stringgrid1.ColCount:=3;
     end;
  1: begin
      stringgrid1.rowcount:=5; stringgrid1.ColCount:=5;
     end;
  2: begin
      stringgrid1.rowcount:=7; stringgrid1.ColCount:=7;
     end;

  end;
  }
end;

procedure Tconvctrlform.UpdateImage;
var ray:array [0..49] of integer;
    EffMatrix2 : array [0..6,0..6] of integer;
    i,j,k:integer;
    mx,divisor:integer;
begin
  gridtomatrix;
  mx:=getmatrixsize();
  k:=0;
  for i:=0 to 49 do ray[i]:=0;
  divisor:=strtoint(edit1.text);

 case mx of
 3: begin
    for i:=2 to 6 do for j:=2 to 6 do
    effmatrix2[i-2,j-2]:=effmatrix[i,j];
      for i:=0 to 2 do for j:=0 to 2 do
      begin
       ray[k]:=effmatrix2[j,i];
       inc(k);
      end;
     ray[49]:=divisor;
    end;
 5: begin
    for i:=1 to 6 do for j:=1 to 6 do
    effmatrix2[i-1,j-1]:=effmatrix[i,j];
      for i:=0 to 4 do for j:=0 to 4 do
      begin
       ray[k]:=effmatrix2[j,i];
       inc(k);
      end;
     ray[49]:=divisor;
    end;
  7: begin
      for i:=0 to 6 do for j:=0 to 6 do
      begin
       ray[k]:=effmatrix[j,i];
       inc(k);
      end;
      ray[49]:=divisor;
     end;
   end;


  applyconvolution(dst.bitmap, ray,mx);
  dst.changed;

end;

function Tconvctrlform.getmatrixsize():integer;
var i:integer;
begin
result:=7;
 for i:=0 to 6 do if effmatrix[i,0]<>0 then exit;
 for i:=0 to 6 do if effmatrix[i,6]<>0 then exit;
 for i:=0 to 6 do if effmatrix[0,i]<>0 then exit;
 for i:=0 to 6 do if effmatrix[6,i]<>0 then exit;
result:=5;
 for i:=1 to 5 do if effmatrix[i,1]<>0 then exit;
 for i:=1 to 5 do if effmatrix[i,5]<>0 then exit;
 for i:=1 to 5 do if effmatrix[1,i]<>0 then exit;
 for i:=1 to 5 do if effmatrix[5,i]<>0 then exit;
result:=3;
end;

procedure Tconvctrlform.FormShow(Sender: TObject);
begin
 tempbmp:=tbitmap32.create;
 tempbmp.assign(dst.bitmap);
 initgrid;
end;

procedure Tconvctrlform.PreviewButtonClick(Sender: TObject);
begin
{ApplyConvolution5x5(dst.bitmap,
      [0, -4, -9, -4, 0, -4, -24, -1, -24, -4, -9, -1, 168, -1, -9, -4, -24, -1, -24, -4,
       0, -4, -9, -4, 0,1]); //lastonedivisor
}
  dst.bitmap.assign(tempbmp);

{ApplyConvolution(dst.bitmap,
    [ 1, 4, 8, 10, 8, 4, 1,
       4,1,25,29,25,12, 4,
       8,25,49,58,49,25, 8,
      10,29,58,67,58,29,10,
       8,25,49,58,49,25, 8,
       4,12,25,29,25,12, 4,
       1, 4, 8, 10, 8, 4, 1,999],7);
   }
updateimage;
dst.changed;

end;

procedure Tconvctrlform.RotateMatrix;
var  i,j:Integer;
     hm : array [0..6,0..6] of integer;

  begin
    //3x3
    hm[3,3]:=effMatrix[3,3];
    hm[2,2]:=effMatrix[3,2];
    hm[3,2]:=effMatrix[4,2];
    hm[4,2]:=effMatrix[4,3];
    hm[4,3]:=effMatrix[4,4];
    hm[4,4]:=effMatrix[3,4];
    hm[3,4]:=effMatrix[2,4];
    hm[2,4]:=effMatrix[2,3];
    hm[2,3]:=effMatrix[2,2];

    //5x5
    for i:=1 to 3 do hm[i,1]:=effMatrix[i+2,1];
    hm[4,1]:=effMatrix[5,2];
    for j:=1 to 3 do hm[5,j]:=effMAtrix[5,j+2];
    hm[5,4]:=effMatrix[4,5];
    for i:=5 downto 3 do hm[i,5]:=effMatrix[i-2,5];
    hm[2,5]:=effMatrix[1,4];
    for j:=5 downto 3 do hm[1,j]:=effMAtrix[1,j-2];
    hm[1,2]:=effMatrix[2,1];

    //7x7
    for i:=0 to 3 do hm[i,0]:=EffMatrix[i+3,0];
    hm[4,0]:=EffMatrix[6,1];
    hm[5,0]:=EffMatrix[6,2];
    for j:=0 to 3 do hm[6,j]:=EffMAtrix[6,j+3];
    hm[6,4]:=EffMatrix[5,6];
    hm[6,5]:=EffMatrix[4,6];

    for i:=6 downto 3 do hm[i,6]:=EffMatrix[i-3,6];
    hm[2,6]:=EffMatrix[0,5];
    hm[1,6]:=EffMatrix[0,4];
    for j:=6 downto 3 do hm[0,j]:=EffMAtrix[0,j-3];
    hm[0,2]:=EffMatrix[1,0];
    hm[0,1]:=EffMatrix[2,0];
//store to matrix
   for i:=0 to 6 do for j:=0 to 6 do
   EffMatrix[i,j]:=hm[i,j];
end;

procedure Tconvctrlform.gridtomatrix;
var i,j:integer;
begin
 for i:=0 to 6 do for j:=0 to 6 do
 EffMatrix[j,i] := StrToInt(StringGrid1.Cells[j,i]);  // Set filter values
end;

procedure Tconvctrlform.matrixtogrid;
var i,j:integer;
begin
 for i:=0 to 6 do for j:=0 to 6 do
 stringgrid1.cells[j,i]:=inttostr(EffMatrix[j,i]);
end;

procedure Tconvctrlform.RotateBtnClick(Sender: TObject);
begin
  gridtomatrix;
  RotateMatrix;
  matrixtogrid;
  PreviewButtonClick(self);
end;


procedure Tconvctrlform.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(5000);
end;

end.
