unit im_resizeFRM;

{*********************************************}
{  This unit is a part of ImageE              }
{  Copyright  2003-2004 R.Geurts             }
{  See Readme.txt for licence information     }
{*********************************************}

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, gr32, gr32_transforms;

type
  TResizeCtrlForm = class(TForm)
    GroupBox1: TGroupBox;
    ActWidEdit: TEdit;
    ActHeiEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ActHPercEdit: TEdit;
    ActVPercEdit: TEdit;
    GroupBox3: TGroupBox;
    TypeCombo: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SynchronCheck: TCheckBox;
    Label7: TLabel;
    RatioEdit: TEdit;
    RatioCheckBox: TCheckBox;
    HelpBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ActWidEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ActHeiEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ActVPercEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ActHPercEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RatioEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure ActualizeValues;
    procedure Resample(Src, Dst: TBitmap32; X, Y: Integer;
      Filter: TStretchFilter);
  public
    FOrgWidth:Integer;
    FOrgHeight:Integer;
    FWidth:Integer;
    FHeight:Integer;
    FHPercent:Integer;
    FVPercent:Integer;
    FSrcBitmap:TBitmap32;
    FDestBitmap:TBitmap32;
    FRatio:Double;
    { Public-Deklarationen }
  end;

var
  ResizeCtrlForm: TResizeCtrlForm;

implementation
uses im_D5;
{$R *.DFM}

procedure TResizeCtrlForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ResizeCtrlFormX := ResizeCtrlForm.left;
  ResizeCtrlFormY:= ResizeCtrlForm.top;
end;

procedure TResizeCtrlForm.FormCreate(Sender: TObject);
begin
  left := ResizeCtrlFormX;
  top := ResizeCtrlFormY;
  TypeCombo.ItemIndex:=3;//6;
  FDestBitmap:=TBitmap32.Create;
  FSrcBitmap:=TBitmap32.Create;
end;

procedure TResizeCtrlForm.FormShow(Sender: TObject);
begin
      Fdestbitmap.assign(fsrcbitmap);
      FOrgWidth:=FSrcBitmap.Width;
      FOrgHeight:=FSrcBitmap.Height;
      FWidth:=FOrgWidth;
      FHeight:=FOrgHeight;
      FHPercent:=100;
      FVPercent:=100;
      FRatio:=FSrcBitmap.Width / FSrcBitmap.Height;
      ActualizeValues;
end;

procedure TResizeCtrlForm.ActualizeValues;
begin
      ActHPercEdit.Text:=IntToStr(FHPercent);
      ActVPercEdit.Text:=IntToStr(FVPercent);
      ActWidEdit.Text:=IntToStr(FWidth);
      ActHeiEdit.Text:=IntToStr(FHeight);
      RatioEdit.Text:=FloatToStr(FRatio);
end;

procedure TResizeCtrlForm.BitBtn1Click(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;
//  CreateXPanel(Self,200,100);
//  XPanel.Caption:='Resampling...';
 try
  case TypeCombo.ItemIndex of

{  0:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,SplineFilter,3,XProgress);
  1:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,BellFilter,3,XProgress);
  2:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,TriangleFilter,3,XProgress);
  3:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,BoxFilter,3,XProgress);
  4:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,HermiteFilter,3,XProgress);
  5:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,Lanczos3Filter,3,XProgress);
  6:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,MitchellFilter,3,XProgress);
SplineFilter
BellFilter
TriangleFilter
BoxFilter
HermiteFilter
Lanczos3Filter
MitchellFilter

Graphex:
TResamplingFilter = (sfBox, sfTriangle, sfHermite, sfBell, sfSpline, sfLanczos3, sfMitchell);
GR32:
sfNearest, sfLinear, sfLinear2, sfSpline
(sfNearest, sfLinear, sfSpline, sfLanczos, sfMitchell)
(sfNearest, sfLinear, sfSpline}
  0:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,sfNearest{sflanczos});
  1:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,sfLinear);
  2:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,sfSpline);
  3:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,sfLanczos);
  4:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,sfMitchell);
{  5:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,sflanczos);
  6:  Resample(FSrcBitmap,FDestBitmap,FWidth,Fheight,sflanczos); }
  end;
 finally
//  ReleaseXPanel;
  Screen.Cursor:=crDefault;
 end;
end;

Procedure TResizeCtrlForm.Resample(Src,Dst: TBitmap32; X,Y: Integer; Filter:TStretchFilter);
Var
RectS: TRect;
RectD: TRect;
{DstClipW,DstClipH:Trect; }
Begin
//(NearestFilter, LinearFilter,SplineFilter, LanczosFilter, MitchellFilter);
RectS.Top := 0;
RectS.Left := 0;
RectS.Right := src.Width;
RectS.Bottom := src.Height;
RectD.Top := 0;
RectD.Left := 0;
RectD.Right := X;
RectD.Bottom := Y;
//DstClipW := DstClip.Right - DstClip.Left;
//DstClipH := DstClip.Bottom - DstClip.Top;
Dst.Clear(clGray32);
Dst.Width:=X;
Dst.Height:=Y;
StretchTransfer(Dst,RectD,RectD,Src, RectS,Filter, dmBlend, Nil);
{ procedure StretchTransfer(
  Dst: TBitmap32; DstRect: TRect; DstClip: TRect;
  Src: TBitmap32; SrcRect: TRect;
  StretchFilter: TStretchFilter;
  CombineOp: TDrawMode; CombineCallBack: TPixelCombineEvent);}
end;




procedure TResizeCtrlForm.ActWidEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Sender as TEdit).Text<>'' then
  begin
    FWidth:=StrToIntdef(ActWidEdit.Text,0);
    if RatioCheckBox.Checked then
    begin
      FHeight:=Round(FWidth / FRatio);
    end;
      FHPercent:=round(FWidth / (FOrgWidth / 100));
      FVPercent:=round(FHeight / (FOrgHeight / 100));
      ActualizeValues;
  end;
end;

procedure TResizeCtrlForm.ActHeiEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Sender as TEdit).Text<>'' then
  begin
    FHeight:=StrToIntdef(ActHeiEdit.Text,0);
    if RatioCheckBox.Checked then
    begin
      FWidth:=Round(FHeight*FRatio);
    end;
      FHPercent:=round(FWidth / (FOrgWidth / 100));
      FVPercent:=round(FHeight / (FOrgHeight / 100));
      ActualizeValues;
  end;
end;

procedure TResizeCtrlForm.ActVPercEditKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Sender as TEdit).Text<>'' then
  begin
    FVPercent:=StrToIntdef(ActVPercEdit.Text,0);
    if SynchronCheck.Checked then
    begin
      FHpercent:=FVPercent;
    end;
      FWidth:=Round((FOrgWidth / 100)*FHPercent);
      Fheight:=Round((FOrgHeight / 100)*FVPercent);
      ActualizeValues;
  end;
end;

procedure TResizeCtrlForm.ActHPercEditKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Sender as TEdit).Text<>'' then
  begin
    FHPercent:=StrToIntdef(ActHPercEdit.Text,0);
    if SynchronCheck.Checked then
    begin
      FVpercent:=FHPercent;
    end;
      FWidth:=Round((FOrgWidth / 100)*FHPercent);
      Fheight:=Round((FOrgHeight / 100)*FVPercent);
      ActualizeValues;
  end;

end;

procedure TResizeCtrlForm.RatioEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Sender as TEdit).Text<>'' then
  FRatio:=StrToFloat(RatioEdit.Text);
  FHeight:=Round(FWidth / FRatio);
  FHPercent:=round(FWidth / (FOrgWidth / 100));
  FVPercent:=round(FHeight / (FOrgHeight / 100));
  ActualizeValues;
end;




procedure TResizeCtrlForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(12000);
end;

end.
